package cz.muni.fi.pb138.domdemo;

import java.io.IOException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 *
 * @author tomp
 */
public class DOMDemos {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws ParserConfigurationException, SAXException, IOException {
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        DocumentBuilder db = dbf.newDocumentBuilder();
        Document doc = db.parse("file:dom.xml");
        traverse(0, doc);
    }

    private static void traverse(int depth, Node node) {
        indent(depth);
        System.out.println("Node type=" + node.getNodeType()
                + " name=" + node.getNodeName() + " value=[" + node.getNodeValue()+"]");
        if (node instanceof Element) {
            Element elt = (Element) node;
            NamedNodeMap atts = elt.getAttributes();
            if (atts.getLength() > 0) {
                indent(depth);
                System.out.println("===Attributes start===");
                for (int i = 0; i < atts.getLength(); i++) {
                    traverse(depth + 1, atts.item(i));
                }
                indent(depth);
                System.out.println("===Attributes end===");
            }
        }
        NodeList children = node.getChildNodes();
        if (children.getLength() > 0) {
            indent(depth);
            System.out.println("===Child nodes start===");
            for (int i = 0; i < children.getLength(); i++) {
                traverse(depth + 1, children.item(i));
            }
            indent(depth);
            System.out.println("===Child nodes end===");
        }
    }

    private static void indent(int depth) {
        for (int i = 0; i < depth; i++) {
            System.out.print("   ");
        }
    }
}
